﻿var confrontationResultsPage;
var btnContinueToGame;
var reactionFeedback;
var reactionTip;
var reactionExtraFeedback;


function initConfrontationResults() {
    confrontationResultsPage = document.getElementById('confrontationResultsPage');
    btnContinueToGame = document.getElementById('btnContinueToGame');
    reactionFeedback = document.getElementById('reactionFeedback');
    reactionTip = document.getElementById('reactionTip');
    reactionExtraFeedback = document.getElementById('reactionExtraFeedback');

    registerClickFor(btnContinueToGame, function () {
        var game = simFamily.domainController.getGameById(simFamily.gameController.currentGameId);
        game.showConfrontationResults = false;
        showOnly(gameboardPage, { id: simFamily.gameController.currentGameId });
    });

    confrontationResultsPage.beforeShowing = function () {
        setBackgroundPatternFor('educator');
        activateClickListenersFor(btnContinueToGame);
        $('.regular-text', reactionTip).text('');
        $('.regular-text', reactionFeedback).text('');
        $('.regular-text', reactionExtraFeedback).text('');
    };

    confrontationResultsPage.loadData = function (params) {
        var game = simFamily.domainController.getGameById(params.id);
        var roundToDisplay = game.currentRound;
        if (game.currentRound > 1) {
            roundToDisplay = game.currentRound - 1;
        }

        simFamily.gameController.currentGameId = game.gameId;
        $('.scenario', confrontationResultsPage).text(game.confrontationResults.scenario);
        //createScoresView($('.scoreBoard', confrontationResultsPage)[0], game.scores);
        changeChildEmotion(game.scores);
        createRoundView($('.roundBoard', confrontationResultsPage)[0], roundToDisplay, game.totalRounds);

        if (game.confrontationResults.winner != null && game.confrontationResults.winner != '') {
            if (game.confrontationResults.winner == loggedInUserName && game.confrontationResults.role == "educator") {
                $('.winner', confrontationResultsPage).text("Goed gedaan, jouw reactie was echt nodig bij deze reactie van het kind");
            }

            if (game.confrontationResults.winner == loggedInUserName && game.confrontationResults.role == "mole") {
                $('.winner', confrontationResultsPage).text("Gefeliciteerd, de opvoeder koos een reactie die niet nodig was bij jouw reactie");
            }

            if (game.confrontationResults.winner != loggedInUserName && game.confrontationResults.role == "educator") {
                $('.winner', confrontationResultsPage).text("Helaas, jouw reactie was niet nodig bij deze reactie van het kind");
            }

            if (game.confrontationResults.winner != loggedInUserName && game.confrontationResults.role == "mole") {
                $('.winner', confrontationResultsPage).text("Helaas, de opvoeder koos voor een passende reactie op jouw reactie");
            }
        }
        else {
            if (game.confrontationResults.role == "educator") {
                $('.winner', confrontationResultsPage).text("Jouw reactie heeft weinig verband met deze reactie van het kind");
            }

            if (game.confrontationResults.role == "mole") {
                $('.winner', confrontationResultsPage).text("De reactie van de opvoeder heeft weinig verband met jouw reactie");
            }
        };

        //$('.educator', confrontationResultsPage).text(data.educator);
        $('.answer', confrontationResultsPage).text(game.confrontationResults.answer);
        $('.reaction', confrontationResultsPage).text(game.confrontationResults.reaction);
        if (hasValue(game.confrontationResults.tip)) {
            $(reactionTip).show();
            $('.regular-text', reactionTip).text(game.confrontationResults.tip);
        }
        if (game.confrontationResults.role == "educator") {
            if (hasValue(game.confrontationResults.feedbackForEducator)) {
                $(reactionFeedback).show();
                $('.regular-text', reactionFeedback).text(game.confrontationResults.feedbackForEducator);
            }
            if (game.confrontationResults.showExtraFeedbackToEducator) {
                $(reactionExtraFeedback).show();
                $('.regular-text', reactionExtraFeedback).text(game.confrontationResults.extraFeedbackForEducator);
            }
        } else {
            if (hasValue(game.confrontationResults.feedbackForMole)) {
                $(reactionFeedback).show();
                $('.regular-text', reactionFeedback).text(game.confrontationResults.feedbackForMole);
            }
            if (game.confrontationResults.showExtraFeedbackToMole) {
                $(reactionExtraFeedback).show();
                $('.regular-text', reactionExtraFeedback).text(game.confrontationResults.extraFeedbackForMole);
            }
        }

        $('.confrontationParticipant.mole', confrontationResultsPage).removeClass('male').removeClass('female').addClass(game.confrontationResults.moleGender);
        $('.confrontationParticipant.educator', confrontationResultsPage).removeClass('male').removeClass('female').addClass(game.confrontationResults.educatorGender);

        confrontationResultsPage.onDataLoaded();
    };

    confrontationResultsPage.beforeLeaving = function () {
        deactivateClickListenersFor(btnContinueToGame);
        $(reactionTip).hide();
        $(reactionFeedback).hide();
        $(reactionExtraFeedback).hide();
    };
};

