﻿simFamily.hintController = {};

simFamily.hintController.init = function () {

    simFamily.hintController.hintsViewed =
    {
        moodButton: false,
        confrontationIcons: false,
        scoreProgressSection: false
    }

    simFamily.hintController.individualHintsToDisplay = [];

    simFamily.signalrController.hub.client.updateHintsViewed = function (data) {
        simFamily.hintController.hintsViewed.moodButton = data.moodButton;
        simFamily.hintController.hintsViewed.confrontationIcons = data.confrontationIcons;
        simFamily.hintController.hintsViewed.scoreProgressSection = data.scoreProgressSection;
        simFamily.hintController.hintsViewed.scenarioDescriptionSection = data.scenarioDescriptionSection;
        simFamily.hintController.hintsViewed.answerListSection = data.answerListSection;
        simFamily.hintController.hintsViewed.scenarioListSection = data.scenarioListSection;
        simFamily.hintController.hintsViewed.resultMessage = data.resultMessage;
        simFamily.hintController.hintsViewed.resultsPageScore = data.resultsPageScore;
        simFamily.hintController.hintsViewed.btnRematch = data.btnRematch;
    }

    simFamily.hintController.hideHints = function () {
        $("#hintSection").hide();
        $("#hintSection input[type=hidden].individualView").val('');
        $("#hintSection .hint").removeClass('selected');
        $(".highlightable").removeClass('highlighted');
    }

    simFamily.hintController.overviewTopLayer = document.getElementById('overviewTopLayer');
    registerClickFor(simFamily.hintController.overviewTopLayer, function () { simFamily.hintController.onTopLayerClicked(); });
    activateClickListenersFor(simFamily.hintController.overviewTopLayer);

    simFamily.hintController.showHint = function (id, individualView) {
        simFamily.hintController.hideHints();
        var hint = $("#hintSection #" + id);
        hint.addClass('selected');
        $("input[type=hidden].individualView", hint).val(individualView);

        if (anyControlHasClass(getControlsToExplainFor(hint), 'highlightable') === false) {
            if (individualView === true) {
                simFamily.hintController.displayIndividualHintsFromQueue();
            }
            else {
                simFamily.hintController.onTopLayerClicked();
            }
            return;
        }

        $("span", hint).show();

        $("#hintSection").show();

        getControlsToExplainFor(hint).show('highlighted');
        getControlsToExplainFor(hint).addClass('highlighted');
        $("#overviewExplanationContainer").css('top', getHintPositionFor(hint));
    }

    simFamily.hintController.onTopLayerClicked = function () {
        var selectedHint = $("#hintSection .hint.selected");
        var viewedProperty = $("input[type=hidden].hintViewedProperty", selectedHint);
        if (viewedProperty.length == 1 && simFamily.hintController.hintsViewed[viewedProperty[0].value] == false) {
            //simFamily.signalrController.hub.server.markHintAsViewed(simFamily.mainController.loggedInUserId, viewedProperty[0].value);
            executeServerCall('markHintAsViewed', [ simFamily.mainController.loggedInUserId,  viewedProperty[0].value ]);
        }

        if (selectedHint) {
            if ($("input[type=hidden].individualView", selectedHint).val() == "true") {
                simFamily.hintController.displayIndividualHintsFromQueue();
            }
            else {
                if ($("input[type=hidden].next-hint-id", selectedHint).val() !== '') {
                    simFamily.hintController.showHint($("input[type=hidden].next-hint-id", selectedHint).val(), false);
                }
                else {
                    simFamily.hintController.displayIndividualHintsFromQueue();
                }
            }
        }
    }

    simFamily.hintController.displayIndividualHintsFromQueue = function () {
        if (simFamily.hintController.individualHintsToDisplay.length > 0) {
            var hintid = simFamily.hintController.individualHintsToDisplay.splice(0, 1)[0];
            simFamily.hintController.showHint(hintid, true);
        }
        else {
            simFamily.hintController.hideHints();
        }
    }
}



function getControlsToExplainFor(elem) {
    return $($("input[type=hidden].control-explained", elem).val());
}

function anyControlHasClass(elems, className) {
    for (i = 0; i < elems.length; i++) {
        if ($(elems[i]).hasClass(className)) {
            return true;
        }
    }

    return false;
}

function getMaximumSizeOfExplainedControls(elem) {
    var controls = getControlsToExplainFor(elem);
    var max = 0;

    for (i = 0; i < controls.length; i++) {
        var size = $(controls[i]).offset().top + $(controls[i]).outerHeight(true);
        if (size > max) {
            max = size;
        }
    }

    return max;
}

function getMinimumSizeOfExplainedControls(elem) {
    var controls = getControlsToExplainFor(elem);
    var min = $(window).height();

    for (i = 0; i < controls.length; i++) {
        var size = $(controls[i]).offset().top;
        if (size < min) {
            min = size;
        }
    }

    return min;
}

function getHintPositionFor(elem) {
    var belowPosition = getMaximumSizeOfExplainedControls(elem);

    if (belowPosition + $("#overviewExplanationContainer").outerHeight() > $(window).height()) {
        return getMinimumSizeOfExplainedControls(elem) - $("#overviewExplanationContainer").outerHeight() - 50; // 50 px is a workaround
    }
    else {
        return belowPosition;
    }
}

function getNextHintControlFor(elem) {
    if ($("input[type=hidden].next-hint-id", elem).val() !== '') {
        return $("#hintSection" + $("input[type=hidden].next-hint-id", elem).val());
    }
    else {
        return null;
    }
}