﻿var dashboardPage;
var receivedInvitationsSection;
var receivedInvitationsList;
var receivedInvitationItemTemplateContainer;
var ownTurnGamesSection;
var ownTurnGamesList;
var opponentTurnGamesSection;
var opponentTurnGamesList;
var gamesInProgressItemTemplateContainer;
var lblGoToHomepageFromDashboard;
//var btnNewGame;
var btnFromDashboardToHistory;
var btnFromDashboardToHome;
var mainMenuHolder;
var btnMenu;


function initDashboard() {
    dashboardPage = document.getElementById('dashboardPage');
    receivedInvitationsSection = document.getElementById('receivedInvitationsSection');
    receivedInvitationsList = document.getElementById('receivedInvitationsList');
    receivedInvitationItemTemplateContainer = document.getElementById('receivedInvitationItemTemplateContainer');
    ownTurnGamesSection = document.getElementById('ownTurnGamesSection'); receivedInvitationsList
    ownTurnGamesList = document.getElementById('ownTurnGamesList');
    opponentTurnGamesSection = document.getElementById('opponentTurnGamesSection');
    opponentTurnGamesList = document.getElementById('opponentTurnGamesList');
    gamesInProgressItemTemplateContainer = document.getElementById('gamesInProgressItemTemplateContainer');
    lblGoToHomepageFromDashboard = document.getElementById('lblGoToHomepageFromDashboard');
    //btnNewGame = document.getElementById('btnNewGame');
    btnFromDashboardToHistory = document.getElementById('btnFromDashboardToHistory');
    btnFromDashboardToHome = document.getElementById('btnFromDashboardToHome');
    btnMenu = document.getElementById('btnMenu');
    mainMenuHolder = document.getElementById('mainMenuHolder');


    registerClickFor(btnFromDashboardToHistory, function () {
        showOnly(historyPage);
    });

    registerClickFor(btnFromDashboardToHome, function () {
        showOnly(homePage);
    });

    registerClickFor(btnMenu, function () {
        var button = $(this);
        if (button.hasClass('on')) {
            hideMenu();
        } else {
            showMenu();
        }
    });


    $("#mainMenuHolder, #mainMenuHolder li").each(function () {
        registerClickFor(this, function () {
            hideMenu();

            if (getDatasetValue(this, 'link') == 'buddyListManagement') {
                showOnly(buddyListManagementPage);
            }

            if (getDatasetValue(this, 'link') == 'installationInvite') {
                showOnly(installationInvitePage);
            }

            if (getDatasetValue(this, 'link') == 'tutorial') {
                showOnly(tutorialPage);
            }

            if (getDatasetValue(this, 'link') == 'aboutHorizon') {
                showOnly(aboutHorizonPage);
            }

            if (getDatasetValue(this, 'link') == 'privacy') {
                showOnly(privacyPage);
            }
        });
    });


    simFamily.signalrController.hub.client.onBuddyAdded = function () {
        showOnly(dashboardPage);
    };

    simFamily.signalrController.hub.client.onGameCreated = function (data) {

        if (data.gameMode === simFamily.gameController.gameMode.singleplayerLevel1
            || data.gameMode === simFamily.gameController.gameMode.singleplayerLevel2
            || data.gameMode === simFamily.gameController.gameMode.singleplayerLevel3) {
            showOnly(gameboardPage, { id: data.gameId });
            return;
        }

        simFamily.signalrController.hub.client.displayToUser('Je uitnodiging is verstuurd naar de tegenstander.');

        showOnly(dashboardPage);
    };

    simFamily.signalrController.hub.client.onRandomGameRequestCreated = function () {
        simFamily.signalrController.hub.client.displayToUser('Je uitnodiging is verstuurd. Je ontvangt een melding zodra eentegenstander je uitnodiging accepteert.');
    };

    //simFamily.signalrController.hub.client.onRandomGameCreated = function (gameid) {
    //    isClean = false;
    //    if (currentPage == dashboardPage) {
    //        showOnly(dashboardPage);
    //    }
    //    else {
    //        addNotification(gameid);
    //    }
    //};

    //simFamily.signalrController.hub.client.onInvitationReceived = function (data) {
    //    if (currentPage == dashboardPage) {
    //        showOnly(dashboardPage);
    //        return;
    //    }

    //    if (currentPage == gameboardPage) {
    //        addNotification(data.gameId);
    //        return;
    //    }

    //    if (currentPage == confrontationResultsPage) {
    //        addNotification(data.gameId);
    //        return;
    //    }

    //    if (currentPage == moodPage) {
    //        addNotification(data.gameId);
    //        return;
    //    }

    //    if (currentPage == rolePage) {
    //        addNotification(data.gameId);
    //        return;
    //    }
    //};

    simFamily.signalrController.hub.client.onPartnerJoinedGame = function (userId, gameId) {
        if (currentPage == dashboardPage) {
            showOnly(dashboardPage);
        }
    };


    simFamily.signalrController.hub.client.onGameFinished = function (gameId, userId) {
        if (currentPage == dashboardPage) {
            showOnly(dashboardPage);
            return;
        };

        if (simFamily.gameController.currentGameId == gameId &&
           (currentPage == gameboardPage ||
            currentPage == rolePage ||
            currentPage == moodPage ||
            currentPage == confrontationResultsPage)) {

            if (userId != simFamily.mainController.loggedInUserId) {
                simFamily.signalrController.hub.client.displayToUser('Je tegenstander heeft het spel verlaten.');
            }

            showOnly(dashboardPage);
        }
    }

    simFamily.signalrController.hub.client.onReceivedInvitationDeleted = function (gameId, userId) {
        if (currentPage == dashboardPage) {
            showOnly(dashboardPage);
        };
    };


    dashboardPage.loadData = function () {
        emptyElement(receivedInvitationsList);
        emptyElement(ownTurnGamesList);
        emptyElement(opponentTurnGamesList);

        var now = Date.now();

        for (var i = 0; i < simFamily.domainController.domain.games.length; i++) {
            if (simFamily.domainController.domain.games[i].state == simFamily.mainController.gameStatus.finished) {
                continue;
            }

            if (simFamily.domainController.domain.games[i].state == simFamily.mainController.gameStatus.waitingForInviteeToJoin) {
                addInvitation(simFamily.domainController.domain.games[i], now);
                continue;
            }

            if (simFamily.domainController.domain.games[i].gameMode == simFamily.gameController.gameMode.singleplayerLevel1 ||
                simFamily.domainController.domain.games[i].gameMode == simFamily.gameController.gameMode.singleplayerLevel2 ||
                simFamily.domainController.domain.games[i].gameMode == simFamily.gameController.gameMode.singleplayerLevel3 ||
                simFamily.domainController.domain.games[i].state == simFamily.mainController.gameStatus.waitingForUsersToReadAnswerOverview ||
                simFamily.domainController.domain.games[i].state == simFamily.mainController.gameStatus.waitingForRemainingUserToReadAnswerOverview) {

                addOwnTurnGame(simFamily.domainController.domain.games[i], now);
                continue;
            }

            if (simFamily.domainController.domain.games[i].state == simFamily.mainController.gameStatus.waintingForMoleToChooseScenario ||
                simFamily.domainController.domain.games[i].state == simFamily.mainController.gameStatus.waintingForMoleToChooseReaction) {
                if (simFamily.domainController.domain.games[i].localUser.role == 'educator') {
                    addOpponentTurnGame(simFamily.domainController.domain.games[i], now);
                }
                else {
                    addOwnTurnGame(simFamily.domainController.domain.games[i], now);
                }
            }

            if (simFamily.domainController.domain.games[i].state == simFamily.mainController.gameStatus.waintingForEducatorToChooseAnswer) {
                if (simFamily.domainController.domain.games[i].localUser.role == 'educator') {
                    addOwnTurnGame(simFamily.domainController.domain.games[i], now);
                }
                else {
                    addOpponentTurnGame(simFamily.domainController.domain.games[i], now);
                }
            }
        }

        // set abandon games
        $("li.game .abandon", dashboardPage).each(function () {
            registerClickFor(this, function () {
                var that = this;
                if (touchIsSupported()) {
                    navigator.notification.confirm(
                        'Weet je zeker dat je het huidige spel wilt afbreken?',  // message
                        function (buttonIndex) {
                            if (buttonIndex == 1) {
                                executeServerCall('finishGame', [parseInt(getDatasetValue(that.parentElement, 'gameid')), simFamily.mainController.loggedInUserId]);
                            }
                        },                      // callback to invoke with index of button pressed
                        'Let op',               // title
                        'Einde,Annuleer'        // buttonLabels
                        );
                }
                else {
                    var r = confirm("Weet je zeker dat je het huidige spel wilt afbreken?");
                    if (r == true) {
                        executeServerCall('finishGame', [parseInt(getDatasetValue(this.parentElement, 'gameid')), simFamily.mainController.loggedInUserId]);
                    }
                }
            });
            activateClickListenersFor(this);
        });

        var recordsExist = false;
        if ($("li", opponentTurnGamesList).length > 0) {
            $(opponentTurnGamesSection).show();
            recordsExist = true;
        }
        else {
            $(opponentTurnGamesSection).hide();
        }

        if ($("li", receivedInvitationsList).length > 0) {
            $(receivedInvitationsSection).show();
            recordsExist = true;
        }
        else {
            $(receivedInvitationsSection).hide();
        }

        if ($("li", ownTurnGamesList).length > 0) {
            $(ownTurnGamesSection).show();
            recordsExist = true;
        }
        else {
            $(ownTurnGamesSection).hide();
        }

        if (recordsExist == false) {
            $(lblGoToHomepageFromDashboard).show();
        }

        dashboardPage.onDataLoaded();
    };

    dashboardPage.beforeShowing = function () {
        setBackgroundPatternFor('educator');
        hideMenu();
        activateClickListenersFor(btnFromDashboardToHistory);
        activateClickListenersFor(btnFromDashboardToHome);
        activateClickListenersFor(btnMenu);
        simFamily.gameController.gameCreationInProgress = false;
        $(lblGoToHomepageFromDashboard).hide();
    }

    dashboardPage.beforeLeaving = function () {
        if (nextPage.id != dashboardPage.id) {
            notifications = [];
        };

        deactivateClickListenersFor(btnMenu);
        deactivateClickListenersFor(btnFromDashboardToHistory);
        deactivateClickListenersFor(btnFromDashboardToHome);
    };
}

function addInvitation(game, now) {
    var item = $(receivedInvitationItemTemplateContainer.children[0]).clone();

    setDatasetValue(item, 'gameid', game.gameId);
    $('.creatorName', item).text(game.opponent.username);

    if ($.inArray(game.gameId, notifications) == -1) {
        $('.receivedInvitationsPreIcon', item).hide();
    }
    else {
        $('.receivedInvitationsPreIcon', item).show();
    };


    var btnAcc = $('.accept', item)[0];
    var btnDel = $('.delete', item)[0];

    registerClickFor(btnAcc, function () {
        disableControl(btnAcc);
        disableControl(btnDel);
        executeServerCall('joinGame', [simFamily.mainController.loggedInUserId, parseInt(getDatasetValue(this.parentElement, 'gameid'))]);
    });
    activateClickListenersFor(btnAcc);


    registerClickFor(btnDel, function () {
        disableControl(btnAcc);
        disableControl(btnDel);
        executeServerCall('deleteReceivedInvitation', [parseInt(getDatasetValue(this.parentElement, 'gameid')), simFamily.mainController.loggedInUserId]);
    });
    activateClickListenersFor(btnDel);

    receivedInvitationsList.appendChild(item[0]);
}



function addOwnTurnGame(game, now) {
    var item = $(gamesInProgressItemTemplateContainer.children[0]).clone();

    setDatasetValue(item, 'gameid', game.gameId);
    $('.opponentName', item).text(game.opponent.username);

    if (game.gameMode == simFamily.gameController.gameMode.multiplayerLevel1 ||
        game.gameMode == simFamily.gameController.gameMode.multiplayerLevel2) {
        $('.opponentRole', item).show().text("(" + game.opponent.role + ")");
    }

    $('.lastActivity', item).text(formatLastActivity(game.lastActivity, now));

    var $favorite = $('.favorite', item);
    if (game.opponent.username != simFamily.settingsController.computerUsername && simFamily.domainController.hasOpponentAsBuddy(game.opponent.username) == false) {
        registerClickFor($favorite[0], function () {
            executeServerCall('addBuddyTo', [simFamily.mainController.loggedInUserId, parseInt(getDatasetValue(this.parentElement, 'gameid'))]);
        });
        activateClickListenersFor($favorite[0]);
    }
    else {
        $favorite.hide();
    }

    if ($.inArray(game.gameId, notifications) == -1) {
        $('.gamesInProgressPreIcon', item).hide();
    }
    else {
        $('.gamesInProgressPreIcon', item).show();
    };

    registerClickFor(item[0], function () {
        $("#ownTurnGamesList li").each(function () {
            deactivateClickListenersFor(this);
        });

        $(this).addClass('selected');
        showOnly(gameboardPage, { id: getDatasetValue(this, 'gameid') });
    });
    activateClickListenersFor(item[0]);

    ownTurnGamesList.appendChild(item[0]);
}

function addOpponentTurnGame(game, now) {
    var item = $(gamesInProgressItemTemplateContainer.children[0]).clone();

    setDatasetValue(item, 'gameid', game.gameId);
    $('.opponentName', item).text(game.opponent.username);
    $('.lastActivity', item).text(formatLastActivity(game.lastActivity, now));

    if (game.gameMode == simFamily.gameController.gameMode.multiplayerLevel1 ||
        game.gameMode == simFamily.gameController.gameMode.multiplayerLevel2) {
        $('.opponentRole', item).show().text("(" + game.opponent.role + ")");
    }


    var $favorite = $('.favorite', item);
    if (game.opponent.username != simFamily.settingsController.computerUsername && simFamily.domainController.hasOpponentAsBuddy(game.opponent.username) == false) {
        registerClickFor($favorite[0], function () {
            executeServerCall('addBuddyTo', [simFamily.mainController.loggedInUserId, parseInt(getDatasetValue(this.parentElement, 'gameid'))]);
        });
        activateClickListenersFor($favorite[0]);
    }
    else {
        $favorite.hide();
    }

    if ($.inArray(game.gameId, notifications) == -1) {
        $('.gamesInProgressPreIcon', item).hide();
    }
    else {
        $('.gamesInProgressPreIcon', item).show();
    };

    registerClickFor(item[0], function () {
        $("#opponentTurnGamesList li").each(function () {
            deactivateClickListenersFor(this);
        });

        $(this).addClass('selected');
        showOnly(gameboardPage, { id: getDatasetValue(this, 'gameid') });
    });
    activateClickListenersFor(item[0]);

    opponentTurnGamesList.appendChild(item[0]);
}

function showMenu() {
    var button = $("#btnMenu", gameboardPage);
    button.addClass('on');

    $("#mainMenuHolder, #mainMenuHolder li").each(function () {
        activateClickListenersFor(this);
    });

    $(mainMenuHolder).show();
}

function hideMenu() {
    var button = $("#btnMenu", gameboardPage);
    button.removeClass('on');

    $("#mainMenuHolder, #mainMenuHolder li").each(function () {
        deactivateClickListenersFor(this);
    });

    $(mainMenuHolder).hide();
}


function formatLastActivity(ticks, now) {
    var dif = now - ticks;

    if (dif < 3600000) {
        return parseInt(dif / 60000) + 'm';
    }

    if (dif < 86400000) {
        return parseInt(dif / 3600000) + 'h';
    }

    return parseInt(dif / 86400000) + 'd';
}