﻿var gameboardPage;
var answerList;
var answerItemTemplateContainer;
var scenarioList;
var scenarioItemTemplateContainer;
var reactionList;
var reactionItemTemplateContainer;
var scoreProgress;
var scoreProgressList;
var btnNextRound;
var nextRoundSection;
var btnFromDashboardToHome;
var scenarioDescriptionSection;
var answerListSection;
var scoreBoardTemplateContainer;
var scenarioDescription;
var notifications = [];
var numberOfNotifications;
var waitingSection;
var reactionListSection;
var waitingMessage;
var btnGameboardHints;
var roundOverviewSection;
var roundFeedback;
var roundTip;
var overviewNextRoundSection;
var btnOverviewNextRound;
var scoreProgressSection;
var btnOverviewScore;
var btnOverviewFeedsAndTips;
var btnScore;
var btnFeedsAndTips;
var reactionExtraFeedback;
var childsFace;
var confrontationSummary;

function initGameboard() {
    gameboardPage = document.getElementById('gameboardPage');
    answerList = document.getElementById('answerList');
    answerItemTemplateContainer = document.getElementById('answerItemTemplateContainer');
    scenarioDescription = document.getElementById('scenarioDescription');
    scoreProgress = document.getElementById('scoreProgress');
    scoreProgressList = document.getElementById('scoreProgressList');
    btnNextRound = document.getElementById('btnNextRound');
    nextRoundSection = document.getElementById('nextRoundSection');
    scenarioDescriptionSection = document.getElementById('scenarioDescriptionSection');
    answerListSection = document.getElementById('answerListSection');
    waitingSection = document.getElementById('waitingSection');
    scenarioList = document.getElementById('scenarioList');
    scenarioItemTemplateContainer = document.getElementById('scenarioItemTemplateContainer');
    reactionList = document.getElementById('reactionList');
    reactionItemTemplateContainer = document.getElementById('reactionItemTemplateContainer');
    scoreBoardTemplateContainer = document.getElementById('scoreBoardTemplateContainer');
    numberOfNotifications = document.getElementById('numberOfNotifications');
    scenarioListSection = document.getElementById('scenarioListSection');
    btnFromGameboardToDashboard = document.getElementById('btnFromGameboardToDashboard');
    reactionListSection = document.getElementById('reactionListSection');
    waitingMessage = document.getElementById('waitingMessage');
    btnGameboardHints = document.getElementById('btnGameboardHints');
    roundOverviewSection = document.getElementById('roundOverviewSection');
    roundFeedback = document.getElementById('roundFeedback');
    roundTip = document.getElementById('roundTip');
    overviewNextRoundSection = document.getElementById('overviewNextRoundSection');
    btnOverviewNextRound = document.getElementById('btnOverviewNextRound');
    scoreProgressSection = document.getElementById('scoreProgressSection');
    btnOverviewScore = document.getElementById('btnOverviewScore');
    btnOverviewFeedsAndTips = document.getElementById('btnOverviewFeedsAndTips');
    btnScore = document.getElementById('btnScore');
    btnFeedsAndTips = document.getElementById('btnFeedsAndTips');
    reactionExtraFeedback = document.getElementById('reactionExtraFeedback');
    childsFace = $('.child .goToScore');
    confrontationSummary = document.getElementById('confrontationSummary');

    adjustNotificationView();

    toggleOverviewScore(false);

    registerClickFor(btnOverviewScore, function () {
        $(btnOverviewScore).hide();
        $(btnOverviewFeedsAndTips).show();
        toggleOverviewScore(true);
    });

    registerClickFor(btnOverviewFeedsAndTips, function () {
        $(btnOverviewFeedsAndTips).hide();
        $(btnOverviewScore).show();
        toggleOverviewScore(false);
    });

    registerClickFor(btnScore, function () {
        $(btnScore).hide();
        $(btnFeedsAndTips).show();
        toggleOverviewScore(true);
    });

    registerClickFor(btnFeedsAndTips, function () {
        $(btnFeedsAndTips).hide();
        $(btnScore).show();
        toggleOverviewScore(false);
    });

    registerClickFor(btnFromGameboardToDashboard, function () {
        showOnly(dashboardPage);
        numberOfNotifications.innerText = '';
    });

    registerClickFor(btnGameboardHints, function () {
        simFamily.hintController.showHint("hint1", false);
    });

    registerClickFor(childsFace[0], function () {
        var child = $('.child');
        if (!$(roundOverviewSection).is(":visible") && !$(waitingSection).is(":visible")) {
            if (child.hasClass('clicked')) {
                child.removeClass('clicked');
                $([scenarioDescriptionSection, answerListSection, scenarioListSection, reactionListSection]).removeClass('child-face-clicked')
                $('#score-progress-during-round').remove();
            } else {
                child.addClass('clicked');
                $([scenarioDescriptionSection, answerListSection, scenarioListSection, reactionListSection]).addClass('child-face-clicked');
                var currentGameId = simFamily.gameController.currentGameId;
                var game = simFamily.domainController.getGameById(currentGameId);
                setScoreProgressFrom(game);
                var scoreProgress = $(scoreProgressSection).clone();
                scoreProgress.attr('id', 'score-progress-during-round');
                scoreProgress.removeClass();
                $(gameboardPage).append(scoreProgress);
            }
        }
    });

    registerClickFor(btnOverviewNextRound, function () {
        $(this).addClass('selected');
        var currentGameId = simFamily.gameController.currentGameId;
        var game = simFamily.domainController.getGameById(currentGameId);
        $(roundOverviewSection).removeClass('default-overview-feeds default-overview-score');
        executeServerCall('signalUserReady', [simFamily.mainController.loggedInUserId, currentGameId]);
    });

    simFamily.signalrController.hub.client.onGameboardActionProcessed = function (data) {
        showOnly(gameboardPage, data);
    };

    simFamily.signalrController.hub.client.showResultsPage = function (data) {
        showOnly(resultsPage, data);
    };

    registerClickFor(btnNextRound, function () {
        deactivateClickListenersFor(btnNextRound);
        var currentGameId = simFamily.gameController.currentGameId;
        var game = simFamily.domainController.getGameById(currentGameId);
        $(roundOverviewSection).removeClass('default-overview-feeds default-overview-score');
        executeServerCall('goToNextRound', [currentGameId]);
    });

    gameboardPage.beforeShowing = function () {
        activateClickListenersFor(btnFromGameboardToDashboard);
        activateClickListenersFor(btnOverviewNextRound);
        activateClickListenersFor(btnOverviewScore);
        activateClickListenersFor(btnScore);
        activateClickListenersFor(btnOverviewFeedsAndTips);
        activateClickListenersFor(btnFeedsAndTips);
        activateClickListenersFor(childsFace[0]);

        adjustNotificationView();
        $(nextRoundSection).hide();
        $('.local-player .icon, .opponent .icon', gameboardPage).removeClass('male female educator mole confrontation highlightable')
        activateClickListenersFor(btnNextRound);
        $(waitingSection).hide();
        $(".scenario, .answer, .reaction", waitingSection).hide();
        $(scenarioDescriptionSection).hide();
        $(scenarioListSection).hide();
        $(answerListSection).hide();
        $(reactionListSection).hide();
        $(waitingMessage).show();
        activateClickListenersFor(btnGameboardHints);
        $(nextRoundSection).removeClass('highlightable');
        if (!$(roundOverviewSection).hasClass('score-visible') || !$(roundOverviewSection).is(':visible'))
            $("#gameboardPage #scoreProgressSection .wallpaper").removeClass('highlightable');
        if (!$('.child .mood').hasClass('highlightable'))
            $('.child .mood').addClass('highlightable');
        if ($('#gameboardPage #scenarioDescriptionSection .wallpaper').hasClass('highlightable'))
            $('#gameboardPage #scenarioDescriptionSection .wallpaper').removeClass('highlightable');
        if ($('#gameboardPage #answerListSection .wallpaper').hasClass('highlightable'))
            $('#gameboardPage #answerListSection .wallpaper').removeClass('highlightable');
        if ($('#gameboardPage #scenarioListSection .wallpaper').hasClass('highlightable'))
            $('#gameboardPage #scenarioListSection .wallpaper').removeClass('highlightable');
        simFamily.hintController.hideHints();
        simFamily.hintController.individualHintsToDisplay = [];
        $(roundOverviewSection).hide();
        $(roundFeedback).toggleOverviewVisibility(false);
        $(roundTip).toggleOverviewVisibility(false);
        $(reactionExtraFeedback).toggleOverviewVisibility(false);
        $(confrontationSummary).toggleOverviewVisibility(false);
        $(scoreProgressSection).show();
    };

    gameboardPage.loadData = function (params) {
        var game = simFamily.domainController.getGameById(params.id);
        simFamily.gameController.currentGameId = game.gameId;

        setBackgroundPatternFor(game.localUser.role);

        if (game.showRole == true) {
            showOnly(rolePage, params);
        }

        if (game.showConfrontationResults == true) {
            showConfrontationResults(game);
        }

        if (game.state == simFamily.mainController.gameStatus.finished) {
            showOnly(resultsPage, params);
            return;
        }


        $('.local-player .icon', gameboardPage).addClass(game.localUser.gender).addClass(game.localUser.role);
        $('.opponent .icon', gameboardPage).addClass(game.opponent.gender).addClass(game.opponent.role);
        $('.opponent .name', gameboardPage).text(game.opponent.username);

        changeChildEmotion(game.scores);;
        var roundToDisplay = game.currentRound;

        if (game.state == simFamily.mainController.gameStatus.waintingForMoleToChooseScenario) {
            if (game.localUser.role == 'educator') {
                $('#waitingSection .scenario', gameboardPage).show();

                if (simFamily.hintController.hintsViewed.scoreProgressSection == false) {
                    //simFamily.hintController.individualHintsToDisplay.push('hint3');
                }

                $(scoreProgressSection).hide();
                if (game.currentRound > 1) {
                    roundToDisplay = game.currentRound - 1;
                }
                $(waitingSection).show();
                $('.child .mood').removeClass('highlightable');
                if (game.currentRound == 1) 
                    $(waitingMessage).show();
                else {
                    setScoreProgressFrom(game);
                }
            }
            else {
                createScenariosListFrom(game);
                $(scenarioListSection).show();
                $('#gameboardPage #scenarioListSection .wallpaper').addClass('highlightable');
            }
        }

        if (game.state == simFamily.mainController.gameStatus.waintingForEducatorToChooseAnswer) {
            if (game.isConfrontationRound === true
                    && game.gameMode != simFamily.gameController.gameMode.singleplayerLevel1
                    && game.gameMode != simFamily.gameController.gameMode.singleplayerLevel2
                    && game.gameMode != simFamily.gameController.gameMode.multiplayerLevel1) {
                $(".local-player .icon, .opponent .icon", gameboardPage).addClass('confrontation highlightable');
                if (simFamily.hintController.hintsViewed.confrontationIcons == false) {
                    simFamily.hintController.individualHintsToDisplay.push('hint2');
                }
            }
            if (game.localUser.role == 'educator') {
                createAnswersListFrom(game);
                scenarioDescription.innerText = game.scenarioDescription;
                $(scenarioDescriptionSection).show();
                $('#gameboardPage #scenarioDescriptionSection .wallpaper').addClass('highlightable');
                $('#gameboardPage #answerListSection .wallpaper').addClass('highlightable');
                $(answerListSection).show();
            }
            else {
                $('#waitingSection .answer', gameboardPage).show();
                $('#waitingSection', gameboardPage).show();

                if (simFamily.hintController.hintsViewed.scoreProgressSection == false) {
                    //simFamily.hintController.individualHintsToDisplay.push('hint3');
                }
                $(scoreProgressSection).hide();
                //setScoreProgressFrom(game);
                $(waitingSection).show();
                if (game.currentRound == 1) {
                    $(waitingMessage).show();
                    $('.child .mood').removeClass('highlightable');
                    $('#scoreProgressSection .wallpaper', gameboardPage).removeClass('highlightable');
                }
                else {
                    //$(waitingMessage).hide();
                    setScoreProgressFrom(game);
                }
                //$(scoreProgress).show();
            }
        }

        if (game.state == simFamily.mainController.gameStatus.waitingForUsersToReadAnswerOverview
            || game.state == simFamily.mainController.gameStatus.waitingForRemainingUserToReadAnswerOverview) {

            if (game.gameMode == simFamily.gameController.gameMode.singleplayerLevel1
                || game.gameMode == simFamily.gameController.gameMode.singleplayerLevel2
                || game.gameMode == simFamily.gameController.gameMode.singleplayerLevel3) {
                $(nextRoundSection).show();
                $(waitingSection).show();
                $(waitingMessage).hide();
                $(scoreProgressSection).hide();
                $(overviewNextRoundSection).hide();
            }
            else $(overviewNextRoundSection).show();
            $('.child .mood').removeClass('highlightable');

            if (game.showConfrontationResults == false && hasValue(game.overview)) {
                if (game.localUser.role == 'educator') {
                    if (game.overview.educatorEndedRound === true) {
                        switchOverviewToWaitingScren();
                    } else setFeedbackAndTip(game, game.overview.feedbackForEducator, game.overview.tip);
                } else {
                    if (game.overview.moleEndedRound === true) {
                        switchOverviewToWaitingScren();
                    } else setFeedbackAndTip(game, game.overview.feedbackForMole, game.overview.tip);
                }
            }
        }


        if (game.state == simFamily.mainController.gameStatus.waintingForMoleToChooseReaction) {
            if (game.isConfrontationRound === true
                    && game.gameMode != simFamily.gameController.gameMode.singleplayerLevel1
                    && game.gameMode != simFamily.gameController.gameMode.singleplayerLevel2
                    && game.gameMode != simFamily.gameController.gameMode.multiplayerLevel1) {
                $(".local-player .icon, .opponent .icon", gameboardPage).addClass('confrontation highlightable');
                if (simFamily.hintController.hintsViewed.confrontationIcons == false) {
                    simFamily.hintController.individualHintsToDisplay.push('hint2');
                }
            }
            if (game.localUser.role == 'educator') {
                $('#waitingSection .reaction', gameboardPage).show();

                setScoreProgressFrom(game);
                $(scoreProgress).show();

                if (simFamily.hintController.hintsViewed.scoreProgressSection == false) {
                    simFamily.hintController.individualHintsToDisplay.push('hint3');
                }

                $(waitingSection).show();
                $('#scoreProgressSection .wallpaper', gameboardPage).removeClass('highlightable');
                $('.child .mood').removeClass('highlightable');
            }
            else {
                createReactionListFrom(game);
                scenarioDescription.innerText = game.scenarioDescription;
                $(scenarioDescriptionSection).show();
                $(reactionListSection).show();
            }
        }

        createRoundView($('.roundBoard', gameboardPage)[0], roundToDisplay, game.totalRounds);

        if (
            (game.gameMode === simFamily.gameController.gameMode.singleplayerLevel1
            || game.gameMode === simFamily.gameController.gameMode.singleplayerLevel2
            || game.gameMode === simFamily.gameController.gameMode.singleplayerLevel3)
            &&
            (game.localUser.role == 'educator')
            &&
            (game.state == simFamily.mainController.gameStatus.waintingForMoleToChooseReaction
            || game.state == simFamily.mainController.gameStatus.waintingForMoleToChooseScenario)
            ) {
            $(waitingMessage).hide();
            $(nextRoundSection).show();
            $(nextRoundSection).addClass('highlightable');
        }

        if (simFamily.hintController.hintsViewed.moodButton == false) {
            simFamily.hintController.individualHintsToDisplay.push('hint1');
        }
        if (simFamily.hintController.hintsViewed.scenarioDescriptionSection == false) {
            simFamily.hintController.individualHintsToDisplay.push('hint4');
        }
        if (simFamily.hintController.hintsViewed.answerListSection == false) {
            simFamily.hintController.individualHintsToDisplay.push('hint5');
        }
        if (simFamily.hintController.hintsViewed.scenarioListSection == false) {
            simFamily.hintController.individualHintsToDisplay.push('hint6');
        }
        
        gameboardPage.onDataLoaded();
    };

    gameboardPage.afterDisplay = function () {
        simFamily.hintController.displayIndividualHintsFromQueue();
    }

    gameboardPage.beforeLeaving = function () {
        //deactivateClickListenersFor($('.goToScore', gameboardPage)[0]);
        deactivateClickListenersFor(btnFromGameboardToDashboard);
        deactivateClickListenersFor(btnGameboardHints);
        deactivateClickListenersFor(btnNextRound);
        deactivateClickListenersFor(btnOverviewNextRound);
        deactivateClickListenersFor(btnOverviewScore);
        deactivateClickListenersFor(btnScore);
        deactivateClickListenersFor(btnOverviewFeedsAndTips);
        deactivateClickListenersFor(btnFeedsAndTips);
        deactivateClickListenersFor(childsFace[0]);

        $('.child .mood').removeClass('highlightable');

        setBackgroundPatternFor('educator');
        simFamily.hintController.hideHints();
    }
}

function toggleOverviewScore(makeScoreVisible) {

    $(roundOverviewSection).removeClass('feedback-visible score-visible');
    if (makeScoreVisible)
        $(roundOverviewSection).addClass('score-visible');
    else $(roundOverviewSection).addClass('feedback-visible');

    var currentGameId = simFamily.gameController.currentGameId;
    var game = simFamily.domainController.getGameById(currentGameId);
    var extraFeedbackVisible = false;
    var confrontationSummaryVisible = false;
    if (game && game.confrontationResults) {
        extraFeedbackVisible = game.confrontationResults.role == "educator" ? game.confrontationResults.showExtraFeedbackToEducator : game.confrontationResults.showExtraFeedbackToMole;
        confrontationSummaryVisible = true;
    }

    extraFeedbackVisible = extraFeedbackVisible && !makeScoreVisible;
    $(reactionExtraFeedback).toggleOverviewVisibility(extraFeedbackVisible);
    confrontationSummaryVisible = confrontationSummaryVisible && !makeScoreVisible;
    $(confrontationSummary).toggleOverviewVisibility(confrontationSummaryVisible);

    var feedBackVisible = !makeScoreVisible;
    var tipVisible = !makeScoreVisible;
    if (game) {
        if (game.showConfrontationResults === true) {
            tipVisible = tipVisible && hasValue(game.confrontationResults.tip)
            feedBackVisible = feedBackVisible && (game.confrontationResults.role == "educator" ? hasValue(game.confrontationResults.feedbackForEducator) : hasValue(game.confrontationResults.feedbackForMole));
        }
        if (game.showConfrontationResults === false) {
            if (game.overview != undefined) {
                tipVisible = tipVisible && hasValue(game.overview.tip);
                feedBackVisible = feedBackVisible && (game.localUser.role == 'educator' ? hasValue(game.overview.feedbackForEducator) : hasValue(game.overview.feedbackForMole));
            } else {
                tipVisible = false;
                feedBackVisible = false;
            }
        }
    }

    $(roundFeedback).toggleOverviewVisibility(feedBackVisible);
    $(roundTip).toggleOverviewVisibility(tipVisible);
    $(scoreProgressSection).toggleOverviewVisibility(makeScoreVisible);
    if (makeScoreVisible) {
        $('#scoreProgressSection .wallpaper', gameboardPage).addClass('highlightable');
    } else $('#scoreProgressSection .wallpaper', gameboardPage).removeClass('highlightable');
}

$.fn.toggleOverviewVisibility = function (visible) {
    $(this).removeClass('overview-invisible overview-visible')
    if (visible)
        $(this).addClass('overview-visible');
    else $(this).addClass('overview-invisible');

    return $(this);
}

function switchOverviewToWaitingScren() {
    $(overviewNextRoundSection).hide();
    $(roundOverviewSection).hide();
    $(scoreProgressSection).hide();
    $(waitingSection).show()
    $(waitingMessage).show();
    $('#scoreProgressSection .wallpaper', gameboardPage).removeClass('highlightable');
    //$('.child .mood').removeClass('highlightable');
}

function setFeedbackAndTip(game, feedback, tip) {
    var visibilityAccordingToScoreDisplay = !$(roundOverviewSection).hasClass('score-visible');
    if (hasValue(feedback) || hasValue(tip)) {
        $(roundOverviewSection).show();
        if (hasValue(tip)) {

            $(roundTip).toggleOverviewVisibility(visibilityAccordingToScoreDisplay);
            $('.regular-text', roundTip).text(tip)
        }
        if (hasValue(feedback)) {
            //$(roundFeedback).show();
            $(roundFeedback).toggleOverviewVisibility(visibilityAccordingToScoreDisplay)
            $('.regular-text', roundFeedback).text(feedback)
        }
        //$('.child .mood').removeClass('highlightable');
        deactivateClickListenersFor(childsFace[0]);
        $(scoreProgressSection).show();
    }
    setScoreProgressFrom(game);
    setDefaultOverviewMode(game);
}

function setDefaultOverviewModeInConfruntation(game) {
    var isOverviewVisible = true; // always visible because of confrontation summary
    //var isOverviewVisible = hasValue(game.confrontationResults.tip);
    //if (game.confrontationResults.role == "educator") {
    //    isOverviewVisible = isOverviewVisible || hasValue(game.confrontationResults.feedbackForEducator);
    //    isOverviewVisible = isOverviewVisible || game.confrontationResults.showExtraFeedbackToEducator;
    //} else {
    //    isOverviewVisible = isOverviewVisible || hasValue(game.confrontationResults.feedbackForMole);
    //    isOverviewVisible = isOverviewVisible || game.confrontationResults.showExtraFeedbackToMole;
    //}
    defaultOverviewToggleScreens(isOverviewVisible);
}

function setDefaultOverviewMode(game) {
    var isOverviewVisible = hasValue(game.overview.tip);
    if (game.localUser.role == 'educator')
        isOverviewVisible = isOverviewVisible || hasValue(game.overview.feedbackForEducator);
    else isOverviewVisible = isOverviewVisible || hasValue(game.overview.feedbackForMole);

    defaultOverviewToggleScreens(isOverviewVisible);
}

function defaultOverviewToggleScreens(isOverviewVisible) {
    $(roundOverviewSection).show();
    if (isOverviewVisible) {
        if (!$(roundOverviewSection).hasClass('default-overview-feeds')) {
            toggleOverviewScore(false);
            $(btnOverviewScore).show();
            $(btnScore).show();
            $(btnOverviewFeedsAndTips).hide();
            $(btnFeedsAndTips).hide();
            $(roundOverviewSection).addClass('default-overview-feeds');
        }
    } else {
        if (!$(roundOverviewSection).hasClass('default-overview-score')) {
            $(btnOverviewScore).hide();
            $(btnOverviewFeedsAndTips).hide();
            $(btnScore).hide();
            $(btnFeedsAndTips).hide();
            toggleOverviewScore(true);
            $(roundOverviewSection).addClass('default-overview-score');
        }
    }
}

function showConfrontationResults(game) {
    if (game.localUser.role == 'educator') {
        if (hasValue(game.overview) && game.overview.educatorEndedRound === true) {
            switchOverviewToWaitingScren();
            return;
        }
    } else {
        if (hasValue(game.overview) && game.overview.moleEndedRound === true) {
            switchOverviewToWaitingScren();
            return;
        }
    }
    var visibilityAccordingToScoreDisplay = !$(roundOverviewSection).hasClass('score-visible');
    if (hasValue(game.confrontationResults)) {
        if (hasValue(game.confrontationResults.tip)) {
            $(roundOverviewSection).show();
            //$(roundTip).show();
            $(roundTip).toggleOverviewVisibility(visibilityAccordingToScoreDisplay);
            $('.regular-text', roundTip).text(game.confrontationResults.tip);
        }
        if ($(roundOverviewSection).hasClass('feedback-visible')) {
            $(confrontationSummary).toggleOverviewVisibility(visibilityAccordingToScoreDisplay);
            $('#confrontationSummaryQuestion').text(game.confrontationResults.scenario && game.confrontationResults.scenario.length > 0 ? game.confrontationResults.scenario : 'Het laden');
            $('#confrontationSummaryAnswer').text(game.confrontationResults.answer && game.confrontationResults.answer.length > 0 ? game.confrontationResults.answer : 'Het laden');
            $('#confrontationSummaryReacion').text(game.confrontationResults.reaction && game.confrontationResults.reaction.length > 0 ? game.confrontationResults.reaction : 'Het laden');
        }
        if (game.confrontationResults.role == "educator") {
            if (hasValue(game.confrontationResults.feedbackForEducator)) {
                $(roundFeedback).toggleOverviewVisibility(visibilityAccordingToScoreDisplay);
                $('.regular-text', roundFeedback).text(game.confrontationResults.feedbackForEducator);
            }
            if (game.confrontationResults.showExtraFeedbackToEducator) {
                $(reactionExtraFeedback).show();
                if ($(roundOverviewSection).hasClass('feedback-visible'))
                    $(reactionExtraFeedback).toggleOverviewVisibility(visibilityAccordingToScoreDisplay);
                $('.regular-text', reactionExtraFeedback).text(game.confrontationResults.extraFeedbackForEducator);
            }
        } else {
            if (hasValue(game.confrontationResults.feedbackForMole)) {
                $(roundFeedback).toggleOverviewVisibility(visibilityAccordingToScoreDisplay);
                $('.regular-text', roundFeedback).text(game.confrontationResults.feedbackForMole);
            }
            if (game.confrontationResults.showExtraFeedbackToMole) {
                $(reactionExtraFeedback).show();
                if ($(roundOverviewSection).hasClass('feedback-visible'))
                    $(reactionExtraFeedback).toggleOverviewVisibility(visibilityAccordingToScoreDisplay);
                $('.regular-text', reactionExtraFeedback).text(game.confrontationResults.extraFeedbackForMole);
            }
        }
        $(scoreProgressSection).show();
        setScoreProgressFrom(game);
        setDefaultOverviewModeInConfruntation(game);
    }
}

function setScoreProgressFrom(data) {
    emptyElement(scoreProgressList);

    var itemAverage = $(resultsProgressItemTemplateContainer.children[0]).clone();
    $('.goal', itemAverage).text('Kind stemming');
    var average = getWeightedAverage(data.scores);
    $('.score-red-zone, .score-green-zone, .score-yellow-zone', itemAverage).addClass('score-average');
    $('.current .score-bar .score-empty-zone', itemAverage).css('width', (100 - average) + '%');
    $('.current .score-bar .score-indicator', itemAverage).css('margin-right', (100 - average) + '%');
    scoreProgressList.appendChild(itemAverage[0]);
    for (var i = 0; i < 5; i++) {

        var item = $(resultsProgressItemTemplateContainer.children[0]).clone();
        var controllerGoal = simFamily.goalController.goals[i];
        $('.goal', item).text(controllerGoal.displayname).addClass(controllerGoal.code);

        $('.current .score-bar .score-empty-zone', item).css('width', (100 - data.scores[i]) + '%').addClass(controllerGoal.code);
        $('.current .score-bar .score-indicator', item).css('margin-right', (100 - data.scores[i]) + '%');

        if (hasValue(data.previousScores) && data.previousScores.length > 0) {
            if (data.previousScores[i] > data.scores[i])
                $('.goal', item).addClass('down');
            if (data.previousScores[i] < data.scores[i])
                $('.goal', item).addClass('up');

            //$('.goal', item).text(simFamily.goalController.goals[i].displayname).addClass(simFamily.goalController.goals[i].code);
            //$('.previous .score-bar', item).css('width', data.previousScores[i] + "%").addClass(controllerGoal.code);
            //$('.previous .scoreValue', item).text(data.previousScores[i]);
        };

        scoreProgressList.appendChild(item[0]);
    };
    $('.previous', gameboardPage).hide();
    //if (!hasValue(data.previousScores) || data.previousScores.length == 0) {
    //    $('.previous', gameboardPage).hide();
    //};
}

function createScenariosListFrom(data) {
    if (data.scenarios == null && data.scenarios.length > 0) return;

    emptyElement(scenarioList);
    for (var i = 0; i < data.scenarios.length; i++) {

        var item = $(scenarioItemTemplateContainer.children[0]).clone();

        setDatasetValue(item, 'scenarioid', data.scenarios[i].id);
        item.addClass(data.scenarios[i].riskiestGoal);
        $('.description', item).text(data.scenarios[i].description);

        registerClickFor(item[0], function () {
            $("#scenarioList li").each(function () {
                deactivateClickListenersFor(this);
            });

            $(this).addClass('selected');

            //simFamily.signalrController.hub.server.selectScenario(simFamily.mainController.loggedInUserId, simFamily.gameController.currentGameId, getDatasetValue(this, 'scenarioid'));
            executeServerCall('selectScenario', [simFamily.mainController.loggedInUserId, simFamily.gameController.currentGameId, parseInt(getDatasetValue(this, 'scenarioid'))]);
        });
        activateClickListenersFor(item[0]);

        scenarioList.appendChild(item[0]);
    }
}

function createAnswersListFrom(data) {
    emptyElement(answerList);

    for (var i = 0; i < data.answers.length; i++) {

        var item = $(answerItemTemplateContainer.children[0]).clone();

        setDatasetValue(item[0], 'answerid', data.answers[i].id);
        $('.description', item).text(data.answers[i].description);

        registerClickFor(item[0], function () {
            $("#answerList li").each(function () {
                deactivateClickListenersFor(this);
            });

            $(this).addClass('selected');

            executeServerCall('selectAnswer', [simFamily.mainController.loggedInUserId, simFamily.gameController.currentGameId, parseInt(getDatasetValue(this, 'answerid'))]);
        });
        activateClickListenersFor(item[0]);

        answerList.appendChild(item[0]);
    };
}

function createReactionListFrom(data) {
    emptyElement(reactionList);

    for (var i = 0; i < data.reactions.length; i++) {

        var item = $(reactionItemTemplateContainer.children[0]).clone();

        setDatasetValue(item[0], 'reactionid', data.reactions[i].id);
        $('.description', item).text(data.reactions[i].description);

        registerClickFor(item[0], function () {
            $("#reactionList li").each(function () {
                deactivateClickListenersFor(this);
            });

            $(this).addClass('selected');
            var game = simFamily.domainController.getGameById(simFamily.gameController.currentGameId);
            ////if (game.gameMode == simFamily.gameController.gameMode.singleplayerLevel1 || game.gameMode == simFamily.gameController.gameMode.singleplayerLevel2 || game.gameMode == simFamily.gameController.gameMode.singleplayerLevel3) {
            //    simFamily.domainController.removeGame(game.gameId, simFamily.domainController.domain.ownTurnGames);
            //    //game.isDirty = true;
            ////};
            //simFamily.signalrController.hub.server.selectReaction(simFamily.mainController.loggedInUserId, simFamily.gameController.currentGameId, getDatasetValue(this, 'reactionid'));
            executeServerCall('selectReaction', [simFamily.mainController.loggedInUserId, simFamily.gameController.currentGameId, parseInt(getDatasetValue(this, 'reactionid'))]);
        });
        activateClickListenersFor(item[0]);

        reactionList.appendChild(item[0]);
    }
}

var addNotificationsFrom = function (list) {
    for (i = 0; i < list.length; i++) {
        if (list[i].gameId != simFamily.gameController.currentGameId) {
            addNotification(list[i].gameId);
        }
    }
    adjustNotificationView();
}

var addNotification = function (gameid, adjust) {
    if ($.inArray(gameid, notifications) != -1) return;
    notifications.push(gameid);
}

var removeNotification = function (gameid) {
    var index = $.inArray(gameid, notifications);
    if (index == -1) return;

    notifications.splice(index, 1);
    adjustNotificationView();
}

var adjustNotificationView = function () {
    if (notifications.length == 0) {
        $(numberOfNotifications).hide();
        $(btnFromGameboardToDashboard).removeClass('on');
    }
    else {
        numberOfNotifications.innerText = notifications.length;
        $(btnFromGameboardToDashboard).addClass('on');
        $(numberOfNotifications).show();
    }
}
