﻿var historyPage;
var finishedGamesList;
var finishedGamesSection;
var btnDeleteFinishedGames;
var btnFromHistoryToDashboard;
var finishedGameItemTemplateContainer;
var lblNoHistoryRecords;


function initHistory() {
    historyPage = document.getElementById('historyPage');
    finishedGamesList = document.getElementById('finishedGamesList');
    finishedGamesSection = document.getElementById('finishedGamesSection');
    btnDeleteFinishedGames = document.getElementById('btnDeleteFinishedGames');
    btnFromHistoryToDashboard = document.getElementById('btnFromHistoryToDashboard');
    finishedGameItemTemplateContainer = document.getElementById('finishedGameItemTemplateContainer');
    lblNoHistoryRecords = document.getElementById('lblNoHistoryRecords');

    registerClickFor(btnFromHistoryToDashboard, function () {
        showOnly(dashboardPage);
    });

    registerClickFor(btnDeleteFinishedGames, function () {
        if (touchIsSupported()) {
            navigator.notification.confirm(
                'Weet je zeker dat je de historie wilt verwijderen?',  // message
                function (buttonIndex) {
                    if (buttonIndex == 1) {
                        executeServerCall('deleteFinishedGamesFor', [simFamily.mainController.loggedInUserId]);
                    }
                },                      // callback to invoke with index of button pressed
                'Let op',               // title
                'Verwijderen,Annuleer'  // buttonLabels
                );
        }
        else {
            var r = confirm("Weet je zeker dat je de historie wilt verwijderen?");
            if (r == true) {
                executeServerCall('deleteFinishedGamesFor', [simFamily.mainController.loggedInUserId]);
            }
        }
    });


    simFamily.signalrController.hub.client.onHistoryDeleted = function () {
        showOnly(historyPage);
    }

    historyPage.loadData = function () {
        // create the finished games list
        emptyElement(finishedGamesList);


        for (var i = 0; i < simFamily.domainController.domain.games.length; i++) {
            if (simFamily.domainController.domain.games[i].state != simFamily.mainController.gameStatus.finished) {
                continue;
            }

            var item = $(finishedGameItemTemplateContainer.children[0]).clone();


            setDatasetValue(item, 'gameid', simFamily.domainController.domain.games[i].gameId);
            $('.opponentName', item).text(simFamily.domainController.domain.games[i].opponent.username);

            registerClickFor(item[0], function () {
                $("#finishedGamesList li").each(function () {
                    deactivateClickListenersFor(this);
                });

                $(this).addClass('selected');
                showOnly(resultsPage, { id: getDatasetValue(this, 'gameid') });
            });

            if (simFamily.domainController.domain.games[i].rematchCreated == false) {
                var rmtchBtn = $('.rematch', item)[0];
                registerClickFor(rmtchBtn, function () {
                    var game = simFamily.domainController.getGameById(parseInt(getDatasetValue(this.parentElement, 'gameid')));
                    simFamily.domainController.removeGame(game.gameId, simFamily.domainController.domain.finishedGames);

                    executeServerCall('createRematch', [simFamily.mainController.loggedInUserId, game.gameId]);
                    disableControl(this);
                });
                activateClickListenersFor(rmtchBtn);
                $(rmtchBtn).removeClass('disabled');
            }

            activateClickListenersFor(item[0]);

            finishedGamesList.appendChild(item[0]);
        }


        if ($("li", finishedGamesList).length > 0) {
            $(finishedGamesSection).show();
            $(btnDeleteFinishedGames).show();
        }
        else {
            $(lblNoHistoryRecords).show();
        }

        historyPage.onDataLoaded();
    }

    historyPage.beforeShowing = function () {
        setBackgroundPatternFor('educator');
        activateClickListenersFor(btnDeleteFinishedGames);
        activateClickListenersFor(btnFromHistoryToDashboard);
        $(finishedGamesSection).hide();
        $(btnDeleteFinishedGames).hide();
        $(lblNoHistoryRecords).hide();
    }


    historyPage.beforeLeaving = function () {
        deactivateClickListenersFor(btnDeleteFinishedGames);
        deactivateClickListenersFor(btnFromHistoryToDashboard);
    };
}