﻿var homePage;
var btnSingleplayerLevel1;
var btnSingleplayerLevel2;
var btnSingleplayerLevel3;
var btnMultiplayerLevel1;
var btnMultiplayerLevel2;
var btnFromHomeToDashboard;

function initHome() {
    homePage = document.getElementById('homePage');
    btnSingleplayerLevel1 = document.getElementById('btnSingleplayerLevel1');
    btnSingleplayerLevel2 = document.getElementById('btnSingleplayerLevel2');
    btnSingleplayerLevel3 = document.getElementById('btnSingleplayerLevel3');
    btnMultiplayerLevel1 = document.getElementById('btnMultiplayerLevel1');
    btnMultiplayerLevel2 = document.getElementById('btnMultiplayerLevel2');
    btnFromHomeToDashboard = document.getElementById('btnFromHomeToDashboard');   


    registerClickFor(btnFromHomeToDashboard, function () {
        showOnly(dashboardPage);
    });

    registerClickFor(btnSingleplayerLevel1, function () {
        isRandomGameRequest = false;
        simFamily.gameController.currentGameMode = simFamily.gameController.gameMode.singleplayerLevel1;
        simFamily.gameController.gameCreationInProgress = true;
        showOnly(profilesPage);
    });

    registerClickFor(btnSingleplayerLevel2, function () {
        isRandomGameRequest = false;
        simFamily.gameController.currentGameMode = simFamily.gameController.gameMode.singleplayerLevel2;
        simFamily.gameController.gameCreationInProgress = true;
        showOnly(profilesPage);
    });

    registerClickFor(btnSingleplayerLevel3, function () {
        isRandomGameRequest = false;
        simFamily.gameController.currentGameMode = simFamily.gameController.gameMode.singleplayerLevel3;
        simFamily.gameController.gameCreationInProgress = true;
        showOnly(profilesPage);
    });

    registerClickFor(btnMultiplayerLevel1, function () {
        simFamily.gameController.currentGameMode = simFamily.gameController.gameMode.multiplayerLevel1;
        simFamily.gameController.gameCreationInProgress = true;
        ensureLogin();
    });

    registerClickFor(btnMultiplayerLevel2, function () {
        simFamily.gameController.currentGameMode = simFamily.gameController.gameMode.multiplayerLevel2;
        simFamily.gameController.gameCreationInProgress = true;
        ensureLogin();
    });



    homePage.beforeShowing = function () {
        setBackgroundPatternFor('educator');
        activateClickListenersFor(btnSingleplayerLevel1);
        activateClickListenersFor(btnSingleplayerLevel2);
        activateClickListenersFor(btnSingleplayerLevel3);
        activateClickListenersFor(btnMultiplayerLevel1);
        activateClickListenersFor(btnMultiplayerLevel2);

        activateClickListenersFor(btnFromHomeToDashboard);

        simFamily.gameController.gameCreationInProgress = false;

        userHasLoggedInBefore = true;
    };


    homePage.loadData = function () {
        homePage.onDataLoaded();
    };


    homePage.beforeLeaving = function () {
        deactivateClickListenersFor(btnSingleplayerLevel1);
        deactivateClickListenersFor(btnSingleplayerLevel2);
        deactivateClickListenersFor(btnSingleplayerLevel3);
        deactivateClickListenersFor(btnMultiplayerLevel1);
        deactivateClickListenersFor(btnMultiplayerLevel2);
        deactivateClickListenersFor(btnFromHomeToDashboard);
    };
}

function ensureLogin() {
    if (!hasValue(localStorage.SimFamily_Username)) {
        showOnly(loginPage);
    }
    else {
        showOnly(findPartnerPage);
    }
}

