﻿var pageSection;
var infConnectionUnavailable;
var scoreBoardItemTemplateContainer;
var resultsProgressItemTemplateContainer;
var previousPage;
var currentPage;
var currentPageParams;
var nextPage;


var infConnectionUnavailable;
var isClean;


function initMaster() {
    pageSection = document.getElementById('pageSection');
    infConnectionUnavailable = document.getElementById('infConnectionUnavailable');
    scoreBoardItemTemplateContainer = document.getElementById('scoreBoardItemTemplateContainer');
    resultsProgressItemTemplateContainer = document.getElementById('resultsProgressItemTemplateContainer');
    //$(".goToScore").each(function () {
    //    registerClickFor(this, function () {
    //        showOnly(moodPage, { gameId: simFamily.gameController.currentGameId });
    //    });
    //});

    simFamily.signalrController.hub.client.displayToUser = function (message) {
        if (touchIsSupported()) {
            navigator.notification.alert(
                message,  // message
                null,     // callback
                'Let op',  // title
                'OK'      // buttonName
            );
        }
        else {
            alert(message);
        };
    };

    simFamily.signalrController.hub.client.onAnonymousUserCreated = function (anonymousUsername) {
        executeServerCall('anonymousLogin', [anonymousUsername]);
    }
}




function createScoresView(element, scores) {
    emptyElement(element);

    var title = $(scoreBoardTemplateContainer.children[0]).clone();
    element.appendChild(title[0]);

    var item;
    for (var i = 0; i < 5; i++) {
        item = $(scoreBoardItemTemplateContainer.children[0]).clone();

        item.addClass(simFamily.goalController.goals[i].code);
        item.text(scores[i]);

        element.appendChild(item[0]);
    }
}

function changeChildEmotion(scores) {
    var sum = 0, average = 0;
    average = getWeightedAverage(scores);
    //console.log(average);
    average = Math.round(average);
    var emotionNumber = 0;
    // red zone
    if (average >= 0 && average <= 7)
        emotionNumber = 20;
    if (average >= 8 && average <= 13)
        emotionNumber = 19;
    if (average >= 14 && average <= 20)
        emotionNumber = 18;
    if (average >= 21 && average <= 27)
        emotionNumber = 17;
    if (average >= 28 && average <= 33)
        emotionNumber = 16;
    if (average >= 34 && average <= 40)
        emotionNumber = 15;

    // yellow zone
    if (average >= 41 && average <= 42)
        emotionNumber = 14;
    if (average >= 43 && average <= 44)
        emotionNumber = 13;
    if (average >= 45 && average <= 46)
        emotionNumber = 12;
    if (average >= 47 && average <= 48)
        emotionNumber = 11;
    if (average >= 49 && average <= 50)
        emotionNumber = 10;
    if (average >= 51 && average <= 52)
        emotionNumber = 9;
    if (average >= 53 && average <= 54)
        emotionNumber = 8;
    if (average >= 55 && average <= 60)
        emotionNumber = 7; // this should be the starting emotion

    // green zone
    if (average >= 61 && average <= 68)
        emotionNumber = 6;
    if (average >= 69 && average <= 74)
        emotionNumber = 5;
    if (average >= 75 && average <= 80)
        emotionNumber = 4;
    if (average >= 81 && average <= 88)
        emotionNumber = 3;
    if (average >= 89 && average <= 94)
        emotionNumber = 2;
    if (average >= 95 && average <= 100)
        emotionNumber = 1;

    $('div.goToScore').removeClass().addClass('goToScore').addClass('childEmotion' + emotionNumber);
}

function getWeightedAverage(scores) {
    var redWeight = 1.5,
        yellowWeight = 1.1,
        greenWeight = 1,
        weightsTotal = 0,
        weightedTotal = 0;
    for (var i = 0; i < scores.length; i++) {
        var weight = greenWeight;
        if (scores[i] <= 40)
            weight = redWeight
        else if (scores[i] <= 60)
            weight = yellowWeight;

        weightsTotal += weight;
        weightedTotal += scores[i] * weight;
    }
    return weightedTotal / weightsTotal;
}

function createRoundView(element, currentRound, totalRounds) {
    emptyElement(element);

    var item = $(roundBoardTemplateContainer.children[0]).clone();
    $('.current-round', item).text(currentRound);
    $('.total-rounds', item).text(totalRounds);

    element.appendChild(item[0]);
}


function setBackgroundPatternFor(role) {
    if (role == 'mole') {
        $('body').addClass('mole');
    }
    else {
        $('body').removeClass('mole');
    }
}


function showOnly(page, params) {
    if (simFamily.domainController.refreshInProgress == true) {
        return;
    }

    isClean = true;
    nextPage = page;

    $(pageSection).hide();

    if (currentPage != undefined && currentPage != null) {
        currentPage.beforeLeaving();
    };

    if (nextPage != undefined && nextPage != null) {
        nextPage.beforeShowing();

        nextPage.onDataLoaded = function () {
            if (isClean === true) {
                if (nextPage != null) {
                    previousPage = currentPage;
                    currentPage = nextPage;
                    currentPageParams = params;
                    nextPage = null;

                    if (previousPage != undefined && previousPage != null) {
                        $(previousPage).hide();
                    };
                    $(currentPage).show();
                    $(pageSection).show();
                    if (currentPage.hasOwnProperty('afterDisplay')) {
                        currentPage.afterDisplay();
                    }
                    $("input").blur();

                    this.onDataLoaded = null;
                    if (navigator.splashscreen != undefined && navigator.splashscreen != null)
                        navigator.splashscreen.hide();
                }
            }
            else {
                showOnly(page, params);
            }
        };

        nextPage.loadData(params);
    };
}

var serverExecTimer;

function refreshDomainWith(data) {
    if (simFamily.domainController.refreshInProgress == true) { return; }

    simFamily.domainController.refreshInProgress = true;

    simFamily.domainController.domain.profiles = data.profiles;
    simFamily.domainController.domain.favorites = data.favorites;

    simFamily.domainController.removeGames(data.games.toDeleteIds);
    simFamily.domainController.addGames(data.games.newGames);
    if (hasValue(currentPage) && (currentPage.id == gameboardPage.id || currentPage.id == dashboardPage.id || currentPage.id == moodPage.id || currentPage.id == rolePage.id)) {
        addNotificationsFrom(data.games.newGames);
    }

    simFamily.domainController.sortGamesByLastActivityDesc();

    simFamily.domainController.refreshInProgress = false;
}


function executeServerCall(method, data) {
    clearTimeout(serverExecTimer);
    latestServerCallTimestamp = Date.now();

    var userid = null;
    if (hasValue(simFamily.mainController.loggedInUserId)) {
        userid = simFamily.mainController.loggedInUserId;
    }

    var gameIds = '';
    var gameStatuses = '';
    if (hasValue(simFamily.domainController.domain)) {
        for (var i = 0; i < simFamily.domainController.domain.games.length; i++) {
            if (simFamily.domainController.domain.games[i].hasOwnProperty('gameId')
                && simFamily.domainController.domain.games[i].hasOwnProperty('state')) {
                gameIds += simFamily.domainController.domain.games[i].gameId + ',';
                gameStatuses += simFamily.domainController.domain.games[i].state + ',';
            }
        };
        gameIds = gameIds.substring(0, gameIds.length - 1);
        gameStatuses = gameStatuses.substring(0, gameStatuses.length - 1);
    }


    serverExecTimer = setTimeout(function () { executeServerCall(''); }, simFamily.settingsController.serverPollingInterval);

    $.ajax({
        type: "POST",
        data: { method: capitaliseFirstLetter(method), methodParamsSer: JSON.stringify(data), timestamp: latestServerCallTimestamp, gameIds: gameIds, gameStatuses: gameStatuses, userId: userid },
        url: simFamily.settingsController.serverUrl + 'Execute',
        traditional: true,
        success: function (returnData) {
            $(infConnectionUnavailable).hide();
            clearTimeout(serverExecTimer);

            if (hasValue(returnData.userMessage)) {
                simFamily.signalrController.hub.client.displayToUser(returnData.userMessage);
            }

            if (hasValue(returnData.latestData) && hasValue(returnData.timestamp) && returnData.timestamp == latestServerCallTimestamp) {
                refreshDomainWith(returnData.latestData);
            }

            if ($("#hintSection").is(':visible') == false && $("#mainMenuHolder").is(':visible') == false) {
                if (hasValue(returnData.clientAction) && hasValue(returnData.clientAction.method)) {
                    executeServerResponse(returnData.clientAction.method, returnData.clientAction.data);
                }
                else {
                    if (hasValue(currentPage) && (currentPage.id == gameboardPage.id || currentPage.id == dashboardPage.id)) {
                        showOnly(currentPage, currentPageParams);
                    }
                }
            }

            serverExecTimer = setTimeout(function () { executeServerCall(''); }, simFamily.settingsController.serverPollingInterval);
        },
        error: function () {
            $(infConnectionUnavailable).show();
        }
    });
}

function executeServerResponse(method, data) {
    if (simFamily.signalrController.hub.client.hasOwnProperty(method)) {
        simFamily.signalrController.hub.client[method](data);
    }
}