﻿var profilesPage;
var profilesList;
var btnStartGame;
var avatarSection;
var btnFromProfilesToHome;
var numberOfRoundSection;
var isRandomGameRequest;

function initProfiles() {
    profilesPage = document.getElementById('profilesPage');
    profilesList = document.getElementById('profilesList');
    btnStartGame = document.getElementById('btnStartGame');
    avatarSection = document.getElementById('avatarSection');
    btnFromProfilesToHome = document.getElementById('btnFromProfilesToHome');
    numberOfRoundSection = document.getElementById('numberOfRoundSection');


    $("span", avatarSection).each(function () {
        registerClickFor(this, function () {
            $("span", avatarSection).removeClass('selected');
            $(this).addClass('selected');
        });
    });

    $("span", numberOfRoundSection).each(function () {
        registerClickFor(this, function () {
            $("span", numberOfRoundSection).removeClass('selected');
            $(this).addClass('selected');
        });
    });

    registerClickFor(btnFromProfilesToHome, function () {
        showOnly(homePage);
    });

    registerClickFor(btnStartGame, function () {
        var selectedProfiles = $(".selected", profilesList);

        if (selectedProfiles.length != 1) {
            simFamily.signalrController.hub.client.displayToUser("Je moet een profiel selecteren.");
            return;
        }

        var selectedAvatars = $(".selected", avatarSection);
        if (selectedAvatars.length != 1) {
            simFamily.signalrController.hub.client.displayToUser("Please select an avatar.");
            return;
        }

        if (isRandomGameRequest == false && selectedOpponentId == null) {
            simFamily.signalrController.hub.client.displayToUser("An opponent should be selected.");
            return;
        }

        var numberOfRounds = getDatasetValue($("span.selected", numberOfRoundSection)[0], 'rounds');
        simFamily.gameController.profileId = getDatasetValue($(".checkbox.selected", profilesList)[0].parentElement, 'profileid');

        if (isRandomGameRequest === true) {
            executeServerCall('createRandomGameRequest', [simFamily.mainController.loggedInUserId, parseInt(simFamily.gameController.profileId), parseInt(numberOfRounds), parseInt(simFamily.gameController.currentGameMode), parseInt(getDatasetValue(selectedAvatars[0], 'gender'))]);

            showOnly(dashboardPage);
        }
        else {
            executeServerCall('createGame', [simFamily.gameController.currentGameMode, simFamily.mainController.loggedInUserId, parseInt(simFamily.gameController.profileId), parseInt(numberOfRounds), parseInt(selectedOpponentId), parseInt(getDatasetValue(selectedAvatars[0], 'gender'))]);

            simFamily.gameController.gameCreationInProgress = false;
        };

        disableControl(btnStartGame);
    });


    profilesPage.loadData = function () {
        emptyElement(profilesList);

        if (simFamily.domainController.domain.profiles.length > 0) {
            for (var i = 0; i < simFamily.domainController.domain.profiles.length; i++) {
                var item = $(profileItemTemplateContainer.children[0]).clone();

                setDatasetValue(item[0], 'profileid', simFamily.domainController.domain.profiles[i].id);

                $('.name', item).text(simFamily.domainController.domain.profiles[i].name);

                registerClickFor(item[0], function () {
                    $(".checkbox", profilesList).removeClass('selected');
                    $(".checkbox", this).addClass('selected');
                });
                activateClickListenersFor(item[0]);

                profilesList.appendChild(item[0]);
            };

            if (simFamily.domainController.domain.profiles.length == 1)
                $(".checkbox", profilesList).addClass('selected');

            var previousProfile = $("li input[type=hidden].profileid[value=" + simFamily.gameController.profileId + "]", profilesList);
            if (previousProfile.length == 1) {
                $(".checkbox", previousProfile[0].parentElement).addClass('selected');
            }
        };

        profilesPage.onDataLoaded();
    };

    profilesPage.beforeShowing = function () {
        setBackgroundPatternFor('educator');
        enableControl(btnStartGame);
        activateClickListenersFor(btnFromProfilesToHome);

        $("span", avatarSection).each(function () {
            activateClickListenersFor(this);
        });

        $("span", numberOfRoundSection).each(function () {
            activateClickListenersFor(this);
        });
    };

    profilesPage.beforeLeaving = function () {
        deactivateClickListenersFor(btnStartGame);
        deactivateClickListenersFor(btnFromProfilesToHome);
        emptyElement(profilesList);

        $("span", avatarSection).each(function () {
            deactivateClickListenersFor(this);
        });

        $("span", numberOfRoundSection).each(function () {
            deactivateClickListenersFor(this);
        });
    };
}


function setGenderForSettingsPage(gender) {
    $("#avatarSection li  input[type=hidden].gender[value=" + gender + "]").addClass('selected');
}