﻿var registerPage;
var txtUsername;
var txtEmail;
var btnRegister;
var btnFromRegisterToLogin;

function initRegister() {
    registerPage = document.getElementById('registerPage');
    txtUsername = document.getElementById('txtUsername');
    txtEmail = document.getElementById('txtEmail');
    btnRegister = document.getElementById('btnRegister');
    btnFromRegisterToLogin = document.getElementById('btnFromRegisterToLogin');

    registerClickFor(btnRegister, function () {
        txtUsername.blur();
        txtEmail.blur();

        var username = txtUsername.value;
        var email = txtEmail.value;

        if (isEmpty(username)) {
            simFamily.signalrController.hub.client.displayToUser('Gebruikersnaam is vereist.');
            return;
        };

        if (isEmpty(email)) {
            simFamily.signalrController.hub.client.displayToUser('E-mailadres is vereist.');
            return;
        };

        if (!validateEmail(email)) {
            simFamily.signalrController.hub.client.displayToUser('E-mailadres is niet juist.');
            return;
        };

        disableControl(btnStartGame);

        //simFamily.signalrController.hub.server.register(txtUsername.value, txtEmail.value, localStorage.SimFamily_Anonymous_Username);
        executeServerCall('register', [txtUsername.value, txtEmail.value, localStorage.SimFamily_Anonymous_Username]);
    });

    registerClickFor(btnFromRegisterToLogin, function () {
        showOnly(loginPage);
    });


    registerPage.beforeShowing = function () {
        setBackgroundPatternFor('educator');
        activateClickListenersFor(btnRegister);
        activateClickListenersFor(btnFromRegisterToLogin);
        txtUsername.value = '';
        txtEmail.value = '';
    }


    registerPage.loadData = function () {
        registerPage.onDataLoaded();
    };

    registerPage.beforeLeaving = function () {
        txtUsername.blur();
        txtEmail.blur();
        deactivateClickListenersFor(btnRegister);
        deactivateClickListenersFor(btnFromRegisterToLogin);
        //txtUsername.value = '';
        //txtEmail.value = '';
    }
}

function validateEmail(email) {
    var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
    return re.test(email);
}

function validateInteger(str) {
    var re = /^\d+$/;
    return re.test(str);
}