﻿var resultsPage;
var resultsList;
var resultsItemTemplateContainer;
var resultsPage;
var btnRematch;
var btnFinish;
var resultMessage;
var btnResultPageHints;

function initResults() {
    resultsPage = document.getElementById('resultsPage');
    resultsList = document.getElementById('resultsList');
    resultsItemTemplateContainer = document.getElementById('resultsItemTemplateContainer');
    resultsPage = document.getElementById('resultsPage');
    btnRematch = document.getElementById('btnRematch');
    btnFinish = document.getElementById('btnFinish');
    resultMessage = document.getElementById('resultMessage');
    btnResultPageHints = document.getElementById('btnResultPageHints');

    registerClickFor(btnRematch, function () {
        var game = simFamily.domainController.getGameById(simFamily.gameController.currentGameId);
        simFamily.domainController.removeGame(game.gameId, simFamily.domainController.domain.finishedGames);

        executeServerCall('createRematch', [simFamily.mainController.loggedInUserId, simFamily.gameController.currentGameId]);
        disableControl(btnRematch);
    });

    registerClickFor(btnResultPageHints, function () {
        simFamily.hintController.showHint("hint7", false);
    });

    registerClickFor(btnFinish, function () {
        showOnly(historyPage);
    });


    simFamily.signalrController.hub.client.goToResultsPage = function (data) {
        if ((currentPage.id == confrontationResultsPage.id || currentPage.id == rolePage.id || currentPage.id == gameboardPage.id || currentPage.id == moodPage.id) && simFamily.gameController.currentGameId != data.gameid) {
            return;
        }

        showOnly(resultsPage, data);
    };

    resultsPage.beforeShowing = function () {
        setBackgroundPatternFor('educator');
        activateClickListenersFor(btnRematch);
        activateClickListenersFor(btnResultPageHints);
        activateClickListenersFor(btnFinish);
        $(btnRematch).show();
        $("span", resultMessage).hide();
        $('#resultsPage #resultMessage').addClass('highlightable');
        $('#resultsPage #resultsPageScore').addClass('highlightable');
        $('#resultsPage #btnRematch').addClass('highlightable');
        $('.local-player .icon, .opponent .icon', resultsPage)
            .removeClass('male').removeClass('female').removeClass('educator').removeClass('mole').removeClass('confrontation');
    };

    resultsPage.loadData = function (params) {
        var game = simFamily.domainController.getGameById(params.id);
        simFamily.gameController.currentGameId = game.gameId;

        $('.local-player .icon', resultsPage).addClass(game.localUser.gender).addClass(game.localUser.role);
        $('.opponent .icon', resultsPage).addClass(game.opponent.gender).addClass(game.opponent.role);
        $('.opponent .name', resultsPage).text(game.opponent.username);


        // create the received invitations list
        emptyElement(resultsList);
        if (game.rematchCreated === true) {
            disableControl(btnRematch);
        }
        else {
            enableControl(btnRematch);
        }

        var itemAverage = $(resultsItemTemplateContainer.children[0]).clone();
        $('.goal', itemAverage).text('Kind stemming');
        var average = getWeightedAverage(game.scores);
        $('.score-red-zone, .score-green-zone, .score-yellow-zone', itemAverage).addClass('score-average');
        $('.score-bar .score-empty-zone', itemAverage).css('width', (100 - average) + '%');
        $('.score-bar .score-indicator', itemAverage).css('margin-right', (100 - average) + '%');
        resultsList.appendChild(itemAverage[0]);

        for (var i = 0; i < 5; i++) {

            var item = $(resultsItemTemplateContainer.children[0]).clone();

            $('.goal', item).text(simFamily.goalController.goals[i].displayname);
            $('.score-bar .score-empty-zone', item).css('width', (100 - game.scores[i]) + "%").addClass(simFamily.goalController.goals[i].code);
            $('.score-bar .score-indicator', item).css('margin-right', (100 - game.scores[i]) + '%');
            //$('.scoreValue', item).text(game.scores[i]);

            resultsList.appendChild(item[0]);
        };

        if (game.gameMode === simFamily.gameController.gameMode.singleplayerLevel1) {
            $(".assessment", resultMessage).show();
        }
        else {
            if (game.winner === localStorage.SimFamily_Username || game.winner === localStorage.SimFamily_Anonymous_Username) {
                $(".winner", resultMessage).show();
            }
            else {
                $(".loser", resultMessage).show();
            }
        }
        if (simFamily.hintController.hintsViewed.resultMessage == false)
            simFamily.hintController.individualHintsToDisplay.push('hint7');
        if (simFamily.hintController.hintsViewed.resultsPageScore == false)
            simFamily.hintController.individualHintsToDisplay.push('hint8');
        if (simFamily.hintController.hintsViewed.btnRematch == false)
            simFamily.hintController.individualHintsToDisplay.push('hint9');

        resultsPage.onDataLoaded();
    };

    resultsPage.afterDisplay = function () {
        simFamily.hintController.displayIndividualHintsFromQueue();
    }

    resultsPage.beforeLeaving = function () {
        deactivateClickListenersFor(btnRematch);
        deactivateClickListenersFor(btnFinish);
        deactivateClickListenersFor(btnResultPageHints);
        $('#resultsPage #resultMessage').removeClass('highlightable');
        $('#resultsPage #resultsPageScore').removeClass('highlightable');
        $('#resultsPage #btnRematch').removeClass('highlightable');
    };
}