﻿var rolePage;
var roleImage;
var btnLeaveRolePage;
var educatorMessage;
var moleMessage;

function initRole() {
    rolePage = document.getElementById('rolePage');
    roleImage = document.getElementById('roleImage');
    btnLeaveRolePage = document.getElementById('btnLeaveRolePage');
    educatorMessage = document.getElementById('educatorMessage');
    moleMessage = document.getElementById('moleMessage');


    registerClickFor(btnLeaveRolePage, function () {
        var game = simFamily.domainController.getGameById(simFamily.gameController.currentGameId);
        game.showRole = false;

        showOnly(gameboardPage, { id: simFamily.gameController.currentGameId });
    });


    rolePage.beforeShowing = function () {
        setBackgroundPatternFor('educator');
        activateClickListenersFor(btnLeaveRolePage);
    };

    rolePage.loadData = function (params) {
        var game = simFamily.domainController.getGameById(params.id);
        var $roleImage = $(roleImage);

        $roleImage.removeClass();
        $roleImage.addClass(game.localUser.role);
        $roleImage.addClass(game.localUser.gender);

        simFamily.gameController.currentGameId = game.gameId;

        setRoleMessage(game.localUser.role);

        rolePage.onDataLoaded();
    };

    rolePage.beforeLeaving = function () {
        deactivateClickListenersFor(btnLeaveRolePage);
    };
}

function setRoleMessage(role) {
    if (role == 'educator') {
        $(educatorMessage).show();
        $(moleMessage).hide();
    }
    if (role == 'mole') {
        $(educatorMessage).hide();
        $(moleMessage).show();
    }
}