﻿function registerClickFor(element, callback) {
    element.clientCallback = callback;

    if (touchIsSupported()) {
        element.onTouchMove = function (e) {
            var x = e.targetTouches[0].clientX;
            var y = e.targetTouches[0].clientY;
            if (Math.sqrt(Math.pow(x - this.x, 2) + Math.pow(y - this.y, 2)) > 50) {
                this.moved = true;
                this.className = this.className.replace(/ ?active/gi, '');
            }
            else {
                if (this.moved == true) {
                    this.moved = false;
                    this.className += ' active';
                }
            }
        };

        element.onTouchEnd = function (e) {
            this.removeEventListener('touchmove', this.onTouchMove, false);
            this.removeEventListener('touchend', this.onTouchEnd, false);

            if (!this.moved && element.clientCallback != null && element.clientCallback != undefined) {
                element.clientCallback();
                this.className = this.className.replace(/ ?active/gi, '');
            }
        };

        element.onTouchStart = function (e) {
            e.stopPropagation();
            this.moved = false;

            this.x = e.targetTouches[0].clientX;
            this.y = e.targetTouches[0].clientY;

            this.addEventListener('touchmove', this.onTouchMove, false);
            this.addEventListener('touchend', this.onTouchEnd, false);

            this.className += ' active';
        };
    }
    else {
        element.addEventListener('click', function (e) {
            e.stopPropagation();
            element.clientCallback();
        }, false);
    }
}


function activateClickListenersFor(element) {
    element.addEventListener('touchstart', element.onTouchStart, false);
}

function deactivateClickListenersFor(element) {
    element.removeEventListener('touchstart', element.onTouchStart, false);
}

function enableControl(element) {
    activateClickListenersFor(element);
    element.className = element.className.replace(/ ?disabled/gi, '');
}

function disableControl(element) {
    deactivateClickListenersFor(element);
    element.className = element.className.replace(/ ?disabled/gi, '');
    element.className += ' disabled';
}
