﻿var tutorialPage;
var btnTutorialPrevious;
var btnTutorialSkip;
var btnTutorialNext;

var currentScreen;

function initTutorial() {
    tutorialPage = document.getElementById('tutorialPage');
    btnTutorialPrevious = document.getElementById('btnTutorialPrevious');
    btnTutorialSkip = document.getElementById('btnTutorialSkip');
    btnTutorialNext = document.getElementById('btnTutorialNext');

    registerClickFor(btnTutorialSkip, function () {
        if (userHasLoggedInBefore == true) {
            showOnly(dashboardPage);
        }
        else {
            showOnly(homePage);
        }
    });

    registerClickFor(btnTutorialPrevious, function () {
        if (currentScreen <= 1) return;

        currentScreen--;
        $('.screen', tutorialPage).hide();
        $('.screen input[type=hidden].order[value=' + currentScreen + ']', tutorialPage).parent().show();

        setButtonsEnableStates();
        setActiveBullet(currentScreen);
    });

    registerClickFor(btnTutorialNext, function () {
        if (currentScreen == 5) {
            if (userHasLoggedInBefore == true) {
                showOnly(dashboardPage);
            }
            else {
                showOnly(homePage);
            }
            return;
        };

        currentScreen++;
        $('.screen', tutorialPage).hide();
        $('.screen input[type=hidden].order[value=' + currentScreen + ']', tutorialPage).parent().show();

        setButtonsEnableStates();
        setActiveBullet(currentScreen);
    });

    tutorialPage.beforeShowing = function () {
        setBackgroundPatternFor('educator');
        currentScreen = 1;
        enableControl(btnTutorialPrevious);
        enableControl(btnTutorialSkip);
        activateClickListenersFor(btnTutorialNext);

        setButtonsEnableStates();
        setActiveBullet(currentScreen);
        $('.screen', tutorialPage).hide();
        $('.screen input[type=hidden].order[value=1]', tutorialPage).parent().show();

        if (userHasLoggedInBefore == false) {
            $(btnTutorialSkip).addClass('toHome');
        }
        else {
            $(btnTutorialSkip).removeClass('toHome');
        }
    }

    tutorialPage.loadData = function () {
        tutorialPage.onDataLoaded();
    };


    tutorialPage.beforeLeaving = function () {
        deactivateClickListenersFor(btnTutorialPrevious);
        deactivateClickListenersFor(btnTutorialSkip);
        deactivateClickListenersFor(btnTutorialNext);
    }
}

function setButtonsEnableStates() {
    if (1 < currentScreen) {
        enableControl(btnTutorialPrevious);
    }
    else {
        disableControl(btnTutorialPrevious);
    }

    if (currentScreen < 6) {
        enableControl(btnTutorialNext);
    }
    else {
        disableControl(btnTutorialNext);
    }
}

function setActiveBullet(order) {
    $('.bullet', tutorialPage).removeClass('active');
    $('.bullet input[type=hidden].order[value=' + order + ']', tutorialPage).parent().addClass('active');
}